/*
 * enemy1.c
 *
 * Last modified: <2008/06/25 20:36:39 +0900> By SUMIDA
 */
#include <SDL.h>
#include "system.h"
#include "texture.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"
#include "sound.h"

void enemy1_init(SHIP_INFO *info) {

	REPORT(format("info=%p, id=%d", info, info->id));
	info->sprite.options |= 10;
	info->sprite.dy = IntToReal(1);
}

void enemy1(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship) {

	switch (info->stat) {
	case SHIP_STAT_APPEAR:
		if (info->count < 0) {
			info->count = 5;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	case SHIP_STAT_MOVE:
		if (info->count < 0) {
			info->count = 5;
			info->stat = SHIP_STAT_NORMAL;
		}
		break;

	case SHIP_STAT_NORMAL:
		if (info->count < 0 && Random(0, 128) < system_info.level) {
			info->count = 5;
			info->stat = SHIP_STAT_FIRE;
		}
		break;

	case SHIP_STAT_FIRE:
		if (info->count < 0 && Random(0, 128) < system_info.level) {
			/* _Pe̔ */
			SHOT_INFO *shot = shot_new(shot_mgr, SHOT_ID_BALLET);

			if (shot != NULL) {
				shot_fire(shot, info, 0, 0);
				shot_homing(shot, ship, IntToReal(1));
			}

			info->count = 5;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	default:
		return;
	}

	/* ʒ[Ŕ] */
	if (info->sprite.dx < 0 && info->sprite.x < IntToReal(10)
		|| info->sprite.dx > 0 && info->sprite.x > IntToReal(WIDTH - 10)) {
		info->sprite.dx = -info->sprite.dx;
	}
}

void enemy1_term(SHIP_INFO *info) {
	REPORT(format("info=%p", info));
}
