/*
 * enemy3.c
 *
 * Last modified: <2008/06/25 20:40:25 +0900> By SUMIDA
 */
#include <SDL.h>
#include "system.h"
#include "texture.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"
#include "sound.h"

void enemy3_init(SHIP_INFO *info) {

	REPORT(format("info=%p, id=%d", info, info->id));
	info->sprite.options |= 12;
	info->sprite.dy = IntToReal(1)>>1;
}

void enemy3(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship) {

	switch (info->stat) {
	case SHIP_STAT_APPEAR:
		/* @ɕύX */
		if (info->sprite.x < ship->sprite.x && info->sprite.dx < 0
			|| info->sprite.x > ship->sprite.x && info->sprite.dx > 0) {

			info->sprite.dx = -info->sprite.dx;
		}

		if (info->count < 0) {
			info->count = 5;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	case SHIP_STAT_MOVE:
		if (info->count < 0) {
			info->count = 5;
			info->stat = SHIP_STAT_NORMAL;
		}
		break;

	case SHIP_STAT_NORMAL:
		if (info->count < 0 && Random(0, 128) < system_info.level) {
			info->count = 5;
			info->stat = SHIP_STAT_FIRE;
		}
		break;

	case SHIP_STAT_FIRE:
		if (info->count < 0 && Random(0, 128) < system_info.level) {
			/* [U[̔ */
			SHOT_INFO *shot = shot_new(shot_mgr, SHOT_ID_RAY1);

			if (shot != NULL) {
				shot_fire(shot, info, 0, 0);
				shot->sprite.dy = IntToReal(2);
				sound_effect(SE_SHOT0);
			}

			info->count = 10;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	default:
		return;
	}
}

void enemy3_term(SHIP_INFO *info) {
	REPORT(format("info=%p", info));
}
