/*
 * enemy4.c
 *
 * Last modified: <2008/06/25 20:40:14 +0900> By SUMIDA
 */
#include <SDL.h>
#include "system.h"
#include "texture.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"
#include "sound.h"

void enemy4_init(SHIP_INFO *info) {

	REPORT(format("info=%p, id=%d", info, info->id));
	info->sprite.options |= 13;
	info->sprite.dy = IntToReal(1);
}

void enemy4(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship) {

	switch (info->stat) {
	case SHIP_STAT_APPEAR:
		if (info->count < 0) {
			info->count = 5;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	case SHIP_STAT_MOVE:
		if (info->count < 0) {
			/* @ɕύX */
			if (info->sprite.x < ship->sprite.x)
				info->sprite.dx = IntToReal((int)Random(2, 6));
			else if (info->sprite.x > ship->sprite.x)
				info->sprite.dx = -IntToReal((int)Random(2, 6));
			else
				info->sprite.dx = 0;

			info->count = 5;
			info->stat = SHIP_STAT_NORMAL;
		}
		break;

	case SHIP_STAT_NORMAL:
		if (info->count < 0 && Random(0, 128) < system_info.level) {
			info->sprite.dx = 0;
			info->sprite.dy = IntToReal(1)>>1;
			info->count = 5;
			info->stat = SHIP_STAT_FIRE;
		}
		break;

	case SHIP_STAT_FIRE:
		if (info->count < 0 && Random(0, 128) < system_info.level) {
			/* [U[̔ */
			SHOT_INFO *shot1 = shot_new(shot_mgr, SHOT_ID_RAY1);
			SHOT_INFO *shot2 = shot_new(shot_mgr, SHOT_ID_RAY1);

			if (shot1 != NULL) {
				shot_fire(shot1, info, IntToReal(-16), 0);
				shot1->sprite.dy = IntToReal(2);
			}

			if (shot2 != NULL) {
				shot_fire(shot2, info, IntToReal(16), 0);
				shot2->sprite.dy = IntToReal(2);
				sound_effect(SE_SHOT0);
			}

			info->sprite.dy = IntToReal(1);
			info->count = 20;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	default:
		return;
	}
}

void enemy4_term(SHIP_INFO *info) {
	REPORT(format("info=%p", info));
}
