/*
 * enemy5.c
 *
 * Last modified: <2008/06/25 20:41:05 +0900> By SUMIDA
 */
#include <SDL.h>
#include "system.h"
#include "texture.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"
#include "sound.h"

extern SHIP_MGR enemy_mgr;

void enemy5_init(SHIP_INFO *info) {

	REPORT(format("info=%p, id=%d", info, info->id));
	info->sprite.options |= 14;
	info->sprite.dy = IntToReal(1);
}

void enemy5(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship) {

	switch (info->stat) {
	case SHIP_STAT_APPEAR:
		/* @ɕύX */
		if (info->sprite.x < ship->sprite.x && info->sprite.dx < 0
			|| info->sprite.x > ship->sprite.x && info->sprite.dx > 0) {

			info->sprite.dx = -info->sprite.dx;
		}

		if (info->count < 0) {
			info->count = 5;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	case SHIP_STAT_MOVE:
		if (info->count < 0) {
			info->count = 5;
			info->stat = SHIP_STAT_NORMAL;
		}
		break;

	case SHIP_STAT_NORMAL:
		if (info->count < 0 && Random(0, 128) < system_info.level) {
			info->count = 5;
			info->stat = SHIP_STAT_FIRE;
		}
		break;

	case SHIP_STAT_FIRE:
		if (info->count < 0 && Random(0, 128) < system_info.level) {
			/* ~TC̔ */
			SHIP_INFO *missile = enemy_new(&enemy_mgr, SHIP_ID_MISSILE,
										   info->sprite.x + IntToReal(30-8),
										   info->sprite.y);

			if (missile != NULL) {

				REPORT(format("info->sprite.x=%d, info->sprite.y=%d, missile->sprite.x=%d, missile->sprite.y=%d",
							  info->sprite.x, info->sprite.y, missile->sprite.x, missile->sprite.y));
				sound_effect(SE_SHOT2);
			}

			info->count = 10;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	default:
		return;
	}
}

void enemy5_term(SHIP_INFO *info) {
	REPORT(format("info=%p", info));
}
