/*
 * input.h
 *
 * Last modified: <2008/06/28 05:55:46 +0900> By SUMIDA
 */
#ifndef INPUT_H_INCLUDED
#define INPUT_H_INCLUDED

#include "real.h"

typedef enum INPUT_ID {
	P1 = 0,
	P2,
	P3,
	P4,
	PLAYER_MAX
} INPUT_ID;

#define AXIS_MAX 4

/* L[ */
#define INPUT_PRESS_MASK      0x000000ff
#define INPUT_PRESS_START     0x00000001
#define INPUT_PRESS_SELECT    0x00000002
#define INPUT_PRESS_BUTTON1   0x00000004
#define INPUT_PRESS_BUTTON2   0x00000008
#define INPUT_PRESS_UP        0x00000010
#define INPUT_PRESS_DOWN      0x00000020
#define INPUT_PRESS_LEFT      0x00000040
#define INPUT_PRESS_RIGHT     0x00000080

/* L[GbW */
#define INPUT_KEYDOWN_MASK    0x0000ff00
#define INPUT_KEYDOWN_START   0x00000100
#define INPUT_KEYDOWN_SELECT  0x00000200
#define INPUT_KEYDOWN_BUTTON1 0x00000400
#define INPUT_KEYDOWN_BUTTON2 0x00000800
#define INPUT_KEYDOWN_UP      0x00001000
#define INPUT_KEYDOWN_DOWN    0x00002000
#define INPUT_KEYDOWN_LEFT    0x00004000
#define INPUT_KEYDOWN_RIGHT   0x00008000

/* L[GbW */
#define INPUT_KEYUP_MASK      0x00ff0000
#define INPUT_KEYUP_START     0x00010000
#define INPUT_KEYUP_SELECT    0x00020000
#define INPUT_KEYUP_BUTTON1   0x00040000
#define INPUT_KEYUP_BUTTON2   0x00080000
#define INPUT_KEYUP_UP        0x00100000
#define INPUT_KEYUP_DOWN      0x00200000
#define INPUT_KEYUP_LEFT      0x00400000
#define INPUT_KEYUP_RIGHT     0x00800000

/* s[gL[ */
#define INPUT_REPEAT_MASK     0xff000000
#define INPUT_REPEAT_START    0x01000000
#define INPUT_REPEAT_SELECT   0x02000000
#define INPUT_REPEAT_BUTTON1  0x04000000
#define INPUT_REPEAT_BUTTON2  0x08000000
#define INPUT_REPEAT_UP       0x10000000
#define INPUT_REPEAT_DOWN     0x20000000
#define INPUT_REPEAT_LEFT     0x40000000
#define INPUT_REPEAT_RIGHT    0x80000000

#define AXIS_RANGE_MIN        -256
#define AXIS_RANGE_MAX         256

#define IS_AXIS_RANGE(_n, _a) \
	(((_a) + AXIS_RANGE_MIN) <= (_n) && (_n) <= ((_a) + AXIS_RANGE_MAX))

extern void input_init(void);
extern void input_read(void);
extern void input_free(void);

extern Uint32 input[];
extern RealVector axis[][2];

#endif
