/*
 * missile.c
 *
 * Last modified: <2008/09/07 05:15:55 +0900> By SUMIDA
 */
#include <SDL.h>
#include "system.h"
#include "texture.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"

void missile_init(SHIP_INFO *info) {

	REPORT(format("info=%p, id=%d", info, info->id));
	info->sprite.options |= 15;
	info->sprite.dy = IntToReal(2);
}

void missile(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship) {

	SURFACE *surface_info = surface_get(info->sprite.surface_id);
	SURFACE *surface_ship = surface_get(ship->sprite.surface_id);

	info->sprite.dx = 0;

	if (info->sprite.y < ship->sprite.y) {
		Real x0 = info->sprite.x + (IntToReal(surface_info->frame_width) >> 1);
		Real x1 = ship->sprite.x + (IntToReal(surface_ship->frame_width) >> 1);

		if (x0 < x1)
			info->sprite.dx = IntToReal(1);
		else if (x0 > x1)
			info->sprite.dx = -IntToReal(1);
	}

	if (info->count < 0) {
		EFFECT_INFO *effect = effect_new(EFFECT_ID_FIRE);

		if (effect != NULL) {
			effect_set_pos(effect, &info->sprite, 0, -IntToReal(25));
			effect->sprite.dx = IntToReal((int)Random(-2, 2));
			effect->sprite.dy = -IntToReal((int)Random(2, 4));
			info->count = 5;
		}
	}
}

void missile_term(SHIP_INFO *info) {
	REPORT(format("info=%p", info));
}

