/*
 * myship.c
 *
 * Last modified: <2008/09/07 05:25:14 +0900> By SUMIDA
 */
#include <stdlib.h>
#include <math.h>
#include <SDL.h>
#include <SDL_image.h>
#include "system.h"
#include "texture.h"
#include "surface.h"
#include "sprite.h"
#include "input.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"
#include "sound.h"
#include "bg.h"/**/

#define SIDE_SPACE   30
#define BOTTOM_SPACE 30

#define FORCE_STORE_1    0x0001
#define FORCE_STORE_2    0x0002
#define FORCE_STORE_3    0x0004
#define FORCE_STORE_4    0x0008
#define FORCE_STORE_MAX  0x000F
#define FORCE_ATTACK     0x0010
#define FORCE_LEVEL_MAX  5
#define FORCE_LEVEL_UP   5

SHIP_INFO *ship  = NULL;

/* @̏ */
void myship_init(SHIP_MGR *mgr) {
	ship = ship_new(mgr, SHIP_ID_ME);
	ship->sprite.x = IntToReal(WIDTH / 2 - 30);
	ship->sprite.y = IntToReal(HEIGHT    - 60);
}

/* @̐ */
void myship_action(SHIP_MGR *mgr, SHOT_MGR *shot_mgr, SHIP_INFO *enemy_mgr) {

	/* @̑ */
	/* TODO : Tj@𓮂B */
	if (input[P1] & INPUT_PRESS_LEFT ) ship->sprite.x -= IntToReal(2);
	if (input[P1] & INPUT_PRESS_RIGHT) ship->sprite.x += IntToReal(2);
	if (input[P1] & INPUT_PRESS_UP   ) ship->sprite.y -= IntToReal(2);
	if (input[P1] & INPUT_PRESS_DOWN ) ship->sprite.y += IntToReal(2);

	if (ship->sprite.x < IntToReal(-SIDE_SPACE))           ship->sprite.x = IntToReal(-SIDE_SPACE);
	if (ship->sprite.x > IntToReal(WIDTH - SIDE_SPACE))    ship->sprite.x = IntToReal(WIDTH - 30);
	if (ship->sprite.y < 0)                                ship->sprite.y = 0;
	if (ship->sprite.y > IntToReal(HEIGHT - BOTTOM_SPACE)) ship->sprite.y = IntToReal(HEIGHT - BOTTOM_SPACE);

	if (input[P1] & INPUT_REPEAT_BUTTON1 && ship->stat != SHIP_STAT_LOST) {
		SHOT_INFO *shot = shot_new(shot_mgr, SHOT_ID_NORMAL);
		if (shot != NULL) {
			shot_fire(shot, ship, 0, -32);
			shot->sprite.dy = IntToReal(-16);
		}
	}

	/* XvCg̐ */
	sprite_action(&ship->sprite);

	/* Ԃɉo */
	switch (ship->stat) {
	case SHIP_STAT_EXPLOSION:
		if (ship->count == 0) {
			sound_stop_effect();
		}
		sound_effect(SE_BOMB2);
		if (ship->count++ > 2) {
			ship->stat = SHIP_STAT_LOST;
			system_info.status = SYSTEM_MODE_OVER;
			sound_music(BGM_03, -1);
		}
		break;
	}

	/* XvCg̕\ */
	/* TODO : Sj@\B */
	if (ship->stat != SHIP_STAT_LOST) {
		sprite_put(&ship->sprite);
	}
}
