/*
 * sample2.c
 *
 * Last modified: <2008/12/08 01:26:35 +0900> By SUMIDA
 */
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <SDL.h>
#include <SDL_image.h>
#include "system.h"
#include "texture.h"
#include "surface.h"
#include "sprite.h"
#include "bg.h"
#include "input.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"
#include "map.h"
#include "sound.h"
#include "myship.h"

SDL_Surface *screen = NULL;
SystemInfo system_info;

SHIP_MGR  ship_mgr;
SHIP_MGR  enemy_mgr;
SHOT_MGR  ship_shot_mgr;
SHOT_MGR  enemy_shot_mgr;

SHIP_INFO ships[SHIP_MAX];
SHIP_INFO enemy[ENEMY_MAX];
SHOT_INFO ship_shot[SHIP_SHOT_MAX];
SHOT_INFO enemy_shot[ENEMY_SHOT_MAX];

extern SHIP_INFO *ship;

static void background_init(void);
static void system_info_draw(SDL_Surface* screen);
static void restart(void);

/* B
 * Ƃ0AsƂ-1ԂB
 */
int Initialize(void) {

	int i;

	/*  */
	srand(time(NULL));

	/* SDL */
	if (SDL_Init(SDL_INIT_VIDEO| SDL_INIT_AUDIO|SDL_INIT_TIMER|SDL_INIT_JOYSTICK) < 0) {
		fprintf(stderr, "SDL̏Ɏs܂F%s\n", SDL_GetError());
		return -1;
	}
	printf("SDL_Init ... done.\n");

	/* ʂ̃^CgύX */
	printf("SDL_WM_SetCaption ... ");
	SDL_WM_SetCaption("My SDL Sample Game", NULL);
	printf("done.\n");

	/* ʂ */
	printf("SDL_SetVideoMode ... ");
	screen = SDL_SetVideoMode(WIDTH, HEIGHT, DEPTH,
							  (system_info.options & SYSTEM_OPT_FULLSCREEN) ?
							  SDL_FULLSCREEN|SDL_HWSURFACE|SDL_DOUBLEBUF:
							  SDL_SWSURFACE);
	if (screen == NULL) {
		fprintf(stderr, "ʂ̏Ɏs܂F%s\n", SDL_GetError());
		SDL_Quit();
		return -1;
	}
	printf("done.\n");

	/*
	 * I[fBI
	 * open 44.1KHz, signed 16bit, system byte order,
	 *      stereo audio, using 4096 byte chunks
	 */
	printf("Mix_OpenAudio ... ");
	if(Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 2, 4096) < 0) {
		fprintf(stderr, "I[fBȈɎs܂F%s\n", SDL_GetError());
		SDL_Quit();
		return -1;
	}
	printf("done.\n");

	printf("SDL_ShowCursor ... ");
	SDL_ShowCursor(SDL_DISABLE);
	printf("done.\n");

	input_init();
	surface_init();
	sprite_init();
	bg_init();
	effect_init();
	sound_init();

	/* eNX`֘At@C̐ݒ */
	surface_load("image/font8x8.png", TEX_FONT);
	surface_load("image/bg.png", TEX_BG);

	surface_load("image/title.png", TEX_TITLE);
	surface_load("image/gameover.png", TEX_GAMEOVER);
	surface_load("image/pause.png", TEX_PAUSE);

	surface_load("image/explosion.png", TEX_EXPLOSION);
	surface_set_frame(TEX_EXPLOSION, 64, 64);
	surface_load("image/bomb.png", TEX_BOMB);
	surface_set_frame(TEX_BOMB, 240, 240);
	surface_load("image/fire.png", TEX_FIRE);
	surface_set_frame(TEX_FIRE, 56, 56);

	surface_load("image/ship.png", TEX_SHIP);
	surface_set_frame(TEX_SHIP, 60, 60);
	surface_load("image/hit.png", TEX_HIT);
	surface_set_frame(TEX_HIT, 32, 32);
	surface_load("image/search.png", TEX_SEARCH);
	surface_set_alpha(TEX_SEARCH, 200);
	surface_load("image/sight.png", TEX_SIGHT);
	surface_load("image/grid.png" , TEX_GRID);
	surface_set_alpha(TEX_GRID, 128);
	surface_load("image/force.png", TEX_FORCE);
	surface_set_alpha(TEX_FORCE, 200);

	surface_load("image/enemy1.png", TEX_ENEMY1);
	surface_set_frame(TEX_ENEMY1, 60, 60);
	surface_load("image/enemy2.png", TEX_ENEMY2);
	surface_set_frame(TEX_ENEMY2, 60, 60);
	surface_load("image/enemy3.png", TEX_ENEMY3);
	surface_set_frame(TEX_ENEMY3, 60, 60);
	surface_load("image/enemy4.png", TEX_ENEMY4);
	surface_set_frame(TEX_ENEMY4, 60, 60);
	surface_load("image/enemy5.png", TEX_ENEMY5);
	surface_set_frame(TEX_ENEMY5, 60, 60);
	surface_load("image/missile.png", TEX_MISSILE);
	surface_set_frame(TEX_MISSILE, 16, 45);

	surface_load("image/boss1.png", TEX_BOSS1);
	surface_set_frame(TEX_BOSS1, 100, 181);
	surface_load("image/boss2.png", TEX_BOSS2);
	surface_set_frame(TEX_BOSS2, 100, 150);

	surface_load("image/shot.png", TEX_SHOT);
	surface_set_frame(TEX_SHOT, 28, 16);
	surface_load("image/ballet.png", TEX_BALLET);
	surface_set_frame(TEX_BALLET, 8, 8);
	surface_load("image/ray1.png", TEX_RAY1);
	surface_load("image/ray2.png", TEX_RAY2);
	surface_load("image/photon.png", TEX_PHOTON);
	surface_set_frame(TEX_PHOTON, 24, 24);

	surface_load("image/moon.png", TEX_MOON);
	surface_load("image/planet.png", TEX_PLANET);

	/* y֘At@C̐ݒ */
	sound_load_music("sound/track010_scramble_ver2.mp3", BGM_SCRAMBLE);
	sound_load_music("sound/Loop_07.mp3" , BGM_01);
	sound_load_music("sound/Loop_113.mp3", BGM_02);
	sound_load_music("sound/Loop_26.mp3" , BGM_03);
	sound_load_effect("sound/tm2_shoot000.wav", SE_SHOT0);
	sound_load_effect("sound/tm2_shoot001.wav", SE_SHOT1);
	sound_load_effect("sound/tm2_sonic000.wav", SE_SHOT2);
	sound_load_effect("sound/tm2_bom001.wav"  , SE_BOMB0);
	sound_load_effect("sound/tm2r_bom26_c.wav", SE_BOMB1);
	sound_load_effect("sound/tm2r_bom31_b.wav", SE_BOMB2);

	/* e}l[W̏ */
	ship_init(&ship_mgr, ships, NUMBEROF(ships));
	ship_init(&enemy_mgr, enemy, NUMBEROF(enemy));

	shot_init(&ship_shot_mgr, ship_shot, NUMBEROF(ship_shot));
	shot_init(&enemy_shot_mgr, enemy_shot, NUMBEROF(enemy_shot));

	system_info.status |= SYSTEM_MODE_READY;

	/* @̐ݒ */
	myship_init(&ship_mgr);
	ship->stat = SHIP_STAT_LOST;

	/* }bv̐ݒ */
	map_init();

	/* wi̐ݒ */
	background_init();

	/* BGM̍Đ */
	sound_music(BGM_SCRAMBLE, -1);

	return 0;
}

/* XV */
void Update(void) {

	/* ͑u̓ǂݍ */
	input_read();

	if (input[P1] & INPUT_KEYDOWN_START) {
		Uint32 mode = system_info.status & SYSTEM_MODE_MASK;

		switch (mode) {
		case SYSTEM_MODE_READY:
		case SYSTEM_MODE_OVER:
			/* Q[JnAĊJ */
			restart();
			break;

		case SYSTEM_MODE_PAUSE:
			/* |[Y@\̉ */
			system_info.status &= ~SYSTEM_MODE_PAUSE;
			break;

		default:
			/* |[Y@\̐ݒ */
			system_info.status |= SYSTEM_MODE_PAUSE;
			break;
		}
	}

	if ((system_info.status & SYSTEM_MODE_MASK) != SYSTEM_MODE_PAUSE) {

		/* \XvCgj */
		sprite_clean();

		/* wĩXN[ */
		/* TODO : Rjwi𓮂B */
		bg[1].ofs_y -= 3;
		bg[2].ofs_y -= 1;

		/* }bv̐ */
		/* TODO : UjG@oB */
		if (!(system_info.status & SYSTEM_MODE_MASK)) {
			map_action();
		}

		/* @Vbg̐ */
		system_info.score += shot_action(&ship_shot_mgr, &enemy_mgr);

		/* G@Vbg̐ */
		system_info.score += shot_action(&enemy_shot_mgr, &ship_mgr);

		/* @̐ */
		myship_action(&ship_mgr, &ship_shot_mgr, &enemy_mgr);

		/* G@̐ */
		enemy_action(&enemy_mgr, &enemy_shot_mgr, ship);

		/* ʌʂ̐ */
		effect_action();

		/* XRA\ */
		font_locate(0, 0, 0);
		font_printf(0, "SCORE:%08d  LEVEL:%02d", system_info.score, system_info.level);
	}
}

/* `悷 */
void Draw(void) {

	/* TODO : Qjʂ\B */
	/* wiƃXvCg`悷 */
	bg_rendaring(screen, 3);
	bg_rendaring(screen, 2);
	bg_rendaring(screen, 1);
	sprite_rendering(screen);
	bg_rendaring(screen, 0);
	system_info_draw(screen);

	/* ʂXV */
	SDL_UpdateRect(screen, 0, 0, 0, 0);
//	SDL_Delay(DELAY);
}

/* C[v */
void MainLoop(void) {

	SDL_Event event;
	double next_frame = SDL_GetTicks();
	double wait = 1000.0 / 60;

	for (;;) {
		/* ׂẴCxg */
		while (SDL_PollEvent(&event)) {
			/* QUIT Cxg邩AESC L[ꂽI */
			if ((event.type == SDL_QUIT) ||
				(event.type == SDL_KEYUP && event.key.keysym.sym == SDLK_ESCAPE))
				return;
		}

		/* 1bԂ60Update悤ɂ */
		if (SDL_GetTicks() >= next_frame) {
			Update();

			/* Ԃ܂ƂDraw */
			if (SDL_GetTicks() < next_frame + wait)
				Draw();
			next_frame += wait;
			SDL_Delay(0);
		}
	}
}


/* Is */
void Finalize(void) {

	surface_free();
	input_free();
	sound_free();

	/* I */
	SDL_Quit();
}


/* C֐ */
int SDL_main(int argc, char* argv[]) {

	typedef struct OPTION_INFO {
		char*  command;
		Uint32 value;
	} OPTION_INFO;

	const static OPTION_INFO options[] = {
		{"-v"      , SYSTEM_OPT_VERBOSE},
		{"-f"      , SYSTEM_OPT_FULLSCREEN},
		{"--full"  , SYSTEM_OPT_FULLSCREEN},
		{"--easy"  , SYSTEM_OPT_LEVEL|SYSTEM_OPT_EASY  },
		{"--normal", SYSTEM_OPT_LEVEL|SYSTEM_OPT_NORNAL},
		{"--hard"  , SYSTEM_OPT_LEVEL|SYSTEM_OPT_HARD  },
		{"--super" , SYSTEM_OPT_LEVEL|SYSTEM_OPT_SUPER },
		{"--hyper" , SYSTEM_OPT_LEVEL|SYSTEM_OPT_HYPER },
	};

	memset(&system_info, 0, sizeof(system_info));

	if (argc > 1) {
		int i;

		for (i = 1; i < argc; i++) {
			char *cmd = argv[i];
			int j;

			if (!strcmp("--help", cmd)) {
				printf("Usage: %s [options]\n"
					   "Options: -v        Verbose mode\n"
					   "         -f or --full Full screen mode\n"
					   "         --easy    Level easy\n"
					   "         --normal  Level normal (default)\n"
					   "         --hard    Level hard\n"
					   "         --super   Level super\n"
					   "         --hyper   Level hyper\n");
				return EXIT_SUCCESS;
			}

			for (j = NUMBEROF(options) - 1; j >= 0 ; j--) {
				const OPTION_INFO *opt = &options[j];

				if (!strcmp(opt->command, cmd)) {
					system_info.options |= opt->value;
					break;
				}
			}

			if (j < 0) {
				fprintf(stderr, "Illegal option: %s\n", cmd);
				return EXIT_FAILURE;
			}
		}
	}

	if (Initialize() < 0)
		return EXIT_FAILURE;

	MainLoop();
	Finalize();

	return EXIT_SUCCESS;
}
/*----------------------------------------------------------------------------*/
/* lower ȏ upper ȉ̗Ԃ */
double Random(double lower, double upper) {
	return ((double)rand() / RAND_MAX) * (upper - lower) + lower;
}

/* Pʉ~̍Wpx߂ */
double angle(double x, double y) {
	double s = sqrt(x * x + y * y);
	double result = (s != 0) ? asin(x / sqrt(x * x + y * y)) / M_PI * 180: 0;
	if (y < 0) result = 360 - result;
	return result;
}

char *format(const char *format, ...) {

	static char buf[1024];

	va_list ap;
	va_start(ap, format);
	vsnprintf(buf, sizeof(buf), format, ap);
	va_end(ap);

	return buf;
}

void report(const char *file, const int line, const char *message) {

	if (system_info.options & SYSTEM_OPT_VERBOSE) {
		printf("%s(%d) %s\n", file, line, message);
	}
}
/*----------------------------------------------------------------------------*/
/* wȉ */
void background_init(void) {

	/* TODO : Pjwiʂ */
	int x, y;

	for (y = 0; y < BG_MAP_HEIGHT + BG_MAP_RESERVE; y++) {
		for (x = 0; x < BG_MAP_WIDTH + BG_MAP_RESERVE; x++) {
/*
			bg[1].map[x][y].surface_id = 1;
			bg[1].map[x][y].map_id = (int)Random(3, 9);
			bg[2].map[x][y].surface_id = 1;
			bg[2].map[x][y].map_id = (int)Random(2, 6);
*/
			if (Random(0, 10) < 1) {
				bg[1].map[x][y].surface_id = 1;
				bg[1].map[x][y].map_id = (int)Random(3, 9);
			}
			if (Random(0, 10) < 1) {
				bg[2].map[x][y].surface_id = 1;
				bg[2].map[x][y].map_id = (int)Random(2, 6);
			}
			bg[3].map[x][y].surface_id = 1;
			bg[3].map[x][y].map_id = 1;
		}
	}
}

/* VXe̕` */
void system_info_draw(SDL_Surface* screen) {

	/* TODO : Wj^Cg\ */
	const static info_id[] = {-1, TEX_TITLE, TEX_GAMEOVER, TEX_PAUSE};
	int id = info_id[system_info.status & SYSTEM_MODE_MASK];

	if (id >= 0) {
		SURFACE *surface = surface_get(id);
		surface_draw(screen, id, (WIDTH - surface->frame_width) / 2, (HEIGHT - surface->frame_height) / 2);
	}
}

/* ăX^[g */
void restart(void) {
	system_info.status = 0;
	system_info.score  = 0;
	system_info.frame  = 0;

	ship_init(&ship_mgr, ships, NUMBEROF(ships));
	ship_init(&enemy_mgr, enemy, NUMBEROF(enemy));
	shot_init(&ship_shot_mgr, ship_shot, NUMBEROF(ship_shot));
	shot_init(&enemy_shot_mgr, enemy_shot, NUMBEROF(enemy_shot));

	myship_init(&ship_mgr);
	map_init();
	effect_clean();
	sound_music(BGM_01, -1);
}
/*----------------------------------------------------------------------------*/
